hdu 5014 贪心+位处理

http://acm.hdu.edu.cn/showproblem.php?pid=5014

题意略。

分析: 通过发现规律贪心处理即可,从n开始反向遍历到0,假设与数i匹配的是 Xi;

那么i^Xi的二进制位一定全1,并且二进制位数等于i的二进制位数

#include <iostream>
#include <stdio.h>
#include <string>
#include <string.h>
#include <algorithm>
const int N=1e5+100;
using namespace std;
typedef long long ll;
int a[N];
int b[N];

int main()
{
    int n;
    while(scanf("%d",&n)!=EOF)
    {
        memset(b,-1,sizeof(b));
        for(int i=0;i<=n;i++)scanf("%d",&a[i]);
        ll sum=0;

        for(int i=n;i>=0;i--)
        {
           if(b[i]!=-1)continue;
           int tmp=i,ans=0,cnt=1;
           while(tmp)
           {
             if((tmp&1)==0)ans+=cnt;
             tmp>>=1;
             cnt*=2;
           }
          sum+=2*(i^ans);
          b[i]=ans;
          b[ans]=i;
        }
        printf("%I64d\n",sum);
        for(int i=0;i<=n;i++)
        {
          if(i==0)printf("%d",b[a[i]]);
          else printf(" %d",b[a[i]]);
        }
        printf("\n");
    }
    return 0;
}
时间: 2024-10-27 02:14:49

hdu 5014 贪心+位处理的相关文章

hdu 5014(贪心+异或 西安网络赛)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5014 Number Sequence Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) Total Submission(s): 681    Accepted Submission(s): 321 Special Judge Problem Description There is

HDU 5014 贪心

2014 ACM/ICPC Asia Regional Xi'an Online 枚举贪心 从最大的一个数开始找能使它的异或值最大的一个数. #include "stdio.h" #include "string.h" int main() { int n,i,j,sum; __int64 ans; int b[100010],a[100010]; while (scanf("%d",&n)!=EOF) { for (i=0;i<=

hdu 5014 Number Sequence(贪心)

题目链接:hdu 5014 Number Sequence 题目大意:给定n,表示有0~n这n+1个数组成的序列a,要求构造一个序列b,同样是由0~n组成,要求∑ai⊕bi尽量大. 解题思路:贪心构造,对于n来说,找到n对应二进制的取反对应的数x,那么从x~n之间的数即可两两对应,然后x-1即是一个子问题. #include <cstdio> #include <cstring> #include <algorithm> using namespace std; con

HDU 5014 Number Sequence 贪心 2014 ACM/ICPC Asia Regional Xi&#39;an Online

尽可能凑2^x-1 #include <cstdio> #include <cstring> const int N = 100005; int a[N], p[N]; int init(int x) { int cnt = 0; while(x > 1) { x /= 2; cnt ++; } return cnt + 1; } int main() { int n; while(~scanf("%d", &n)){ for(int i = 0;

HDU 5014 Number Sequence ( 构造 )

HDU 5014 Number Sequence ( 构造 ) 题目意思: 给出一个数列 由0 - n 组成 然后需要构造一个数列 (也是由0-n组成),使得 sum(A[i] ^ B[i])的值最大. 分析: 异或不能出现比这个数大的情况,,所以要从大的数往前找. 现计算出当前判断数的二进制位的位数m,然后再与2^m - 1进行异或,这样会保证最大,具体为什么,自己可以想一想 比如: 5 - 101 -- 3位 - 对应 111 101 ^ 111 = 010 代码: #include <cs

HDU 5014 Number Sequence(2014 ACM/ICPC Asia Regional Xi&#39;an Online) 题解

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5014 Number Sequence Problem Description There is a special number sequence which has n+1 integers. For each number in sequence, we have two rules: ● ai ∈ [0,n] ● ai ≠ aj( i ≠ j ) For sequence a and sequ

hdu 4105 贪心思想

淋漓尽致的贪心思想 波谷一定是一位数,波峰一位数不够大的时候添加到两位数就一定够大了的. 当在寻找波谷碰到零了就自然当成波谷. 当在寻找波峰时碰到零时,将前面的波谷加到前一个波峰上,让当前的零做波谷,使得波谷的值尽量小,这就是本题最关键的贪心思想,一直想不到. 代码中:a表示前一个值,b表示当前考虑的值,tag为偶数时表示正在寻找波谷,奇数时在寻找波峰. #include<iostream> #include<cstdio> #include<cstring> #inc

HDU 5014 Number Sequence(西安网络赛H题)

HDU 5014 Number Sequence 题目链接 思路:对于0-n,尽量不让二进制中的1互相消掉就是最优的,那么只要两个数只要互补就可以了,这样每次从最大的数字,可以找到和他互补的数字,然后这个区间就能确定了,然后剩下的递归下去为一个子问题去解决 代码: #include <cstdio> #include <cstring> const int N = 100005; int n, a[N], ans[N]; int cnt[N]; int count(int x) {

HDU 4923 (贪心+证明)

Room and Moor Problem Description PM Room defines a sequence A = {A1, A2,..., AN}, each of which is either 0 or 1. In order to beat him, programmer Moor has to construct another sequence B = {B1, B2,... , BN} of the same length, which satisfies that: